<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>

<body>
    <link rel="stylesheet" href="./static/loader.css">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-0evHe/X+R7YkIZDRvuzKMRqM+OrBnVFBL6DOitfPri4tjfHxaWutUpFmBp4vmVor" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"
        integrity="sha512-894YE6QWD5I59HgZOGReFYm4dnWc1Qt5NtvYSaNcOP+u1T9qYdvdihz0PPSiiqn/+/3e7Jo4EaG7TubfWGUrMQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <script type="text/javascript" charset="utf8"
        src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.js"></script>

    <link href="https://netdna.bootstrapcdn.com/bootstrap/2.3.2/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.2.0/css/datepicker.min.css"
        rel="stylesheet">

    <script src="https://netdna.bootstrapcdn.com/bootstrap/2.3.2/js/bootstrap.min.js"></script>
    <script
        src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.2.0/js/bootstrap-datepicker.min.js"></script>

    <br />
    <h2 class="text-center">Recursos Máquinas Virtuales</h1>
        <div class="row">
            <div class="col-1">
            </div>
            <div class="col-3">
                <label for="dateInicio">Fecha inicial:</label>
                <input type="text" class="form-control" name="dateInicio" id="dateInicio" />
            </div>
            <div class="col-3">
                <label for="dateFin">Fecha final:</label>
                <input type="text" class="form-control" name="dateFin" id="dateFin" />
            </div>
            <div class="col-3">
                <label for=""></label>
                <button id="btnGenerar" class="btn -btn-success">Aceptar</button>
            </div>
        </div>

        <div class="row" id="loader" style="display: none;">
            <div class="col-4"></div>
            <div class="col-4">
                <div class="d-flex align-items-center">
                    <strong>Generando csv...</strong>
                    <div class="spinner-border ms-auto" role="status" aria-hidden="true"></div>
                </div>
            </div>
            <div class="col-4"></div>
        </div>

        <div id="divBtns" class="row form-group" style="display: none;">
            <a id="aDownload" class="btn btn-succes" href="static/out.csv">Descargar</a>
            <a id="aVer" class="btn btn-succes" href="data">Ver</a>
        </div>


        <script>
            var dpIni = $("#dateInicio").datepicker({
                format: "mm-yyyy",
                startView: "months",
                minViewMode: "months"
            });
            var dpFin = $("#dateFin").datepicker({
                format: "mm-yyyy",
                startView: "months",
                minViewMode: "months"
            });

            $("#btnGenerar").click(() => {
                getCSV();
            })


            var getCSV = async () => {
                var ini = dpIni.datepicker('getDate')
                var fin = dpFin.datepicker('getDate')
                if (ini <= fin) {
                    $("#divBtns").hide();
                    $("#loader").show();
                    $("#btnGenerar").prop('disabled', true)
                    const rawResponse = await fetch('/api/csv', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json'
                        },
                        body: JSON.stringify(
                            {
                                anioIni: ini.getFullYear(),
                                mesIni: ini.getMonth() + 1,
                                anioFin: fin.getFullYear(),
                                mesFin: fin.getMonth() + 1
                            }
                        )
                    });
                    const content = await rawResponse.json();
                    console.log(content);
                    $("#divBtns").show();
                    $("#loader").hide();
                    $("#btnGenerar").prop('disabled', false)
                }
                else {
                    alert("Seleccione un rango válido")
                }
            }

        </script>
</body>

</html>